<?php
/**
 * ###############################################
 *
 * SWIFT Framework
 * _______________________________________________
 *
 * @author         Varun Shoor
 *
 * @package        SWIFT
 * @copyright      Copyright (c) 2001-2012, Kayako
 * @license        http://www.kayako.com/license
 * @link           http://www.kayako.com
 *
 * ###############################################
 */

class SWIFT_SetupDatabase_sugarcrm extends SWIFT_SetupDatabase
{
	public function __construct()
	{
		parent::__construct("sugarcrm");

		return true;
	}

	public function __destruct()
	{
		parent::__destruct();

		return true;
	}

	private function ImportSettings()
	{
		$this->Load->Library('Settings:SettingsManager');
		$this->SettingsManager->Import('./' . SWIFT_APPSDIRECTORY . '/sugarcrm/config/settings.xml');
	}

	public function Install($_pageIndex)
	{
		parent::Install($_pageIndex);
		$this->ImportSettings();

		// ======= CRON =======
		SWIFT_Cron::Create('SugarCRMAccountListing', 'sugarcrm', 'SugarCRMFetchAccountMinute', 'SugarCRMFetchAccount', '0', '1', '0', true);
		SWIFT_Cron::Create('SugarCRMUserListing', 'sugarcrm', 'SugarCRMFetchUserMinute', 'SugarCRMFetchUser', '0', '1', '0', true);

		return true;
	}

	public function Uninstall()
	{
		parent::Uninstall();
		SWIFT_Cron::DeleteOnName(array('SugarCRMAccountListing'));
		SWIFT_Cron::DeleteOnName(array('SugarCRMUserListing'));

		return true;
	}

	public function Upgrade()
	{
		$this->ImportSettings();

		return parent::Upgrade();
	}

	public function LoadTables()
	{
		$this->AddTable('sugarcrmaccountinfo', new SWIFT_SetupDatabaseTable(TABLE_PREFIX . "sugarcrmaccountinfo", "sugarcrmaccountinfoid I PRIMARY AUTO NOTNULL,
        																								parentaccountid I DEFAULT 0 NOTNULL,
                                                                                                        accountid C(255) DEFAULT '' NOTNULL"));

		$this->AddTable('sugarcrmuserinfo', new SWIFT_SetupDatabaseTable(TABLE_PREFIX . "sugarcrmuserinfo", "sugarcrmuserinfoid I PRIMARY AUTO NOTNULL,
																										kuserid I DEFAULT 0 NOTNULL,
                                                                                                        userid C(255) DEFAULT '' NOTNULL"));

		return true;
	}
}